// Library, connections and info from: https://www.waveshare.com/wiki/E-Paper_ESP32_Driver_Board#Resource
// Display: https://www.waveshare.com/product/4.2inch-e-paper.htm

/* Includes ------------------------------------------------------------------*/
#include "DEV_Config.h"
#include "EPD.h"
#include "GUI_Paint.h"
#include <stdlib.h>
#include "ImageData.h"

void setup()
{
    Serial.begin(115200);
    Serial.println("Booting");
    DEV_Module_Init(); //4.2"  400x300px

    Serial.println("e-Paper Init");
    EPD_4IN2_Init_Fast();

    Serial.println("e-Paper clear");
    EPD_4IN2_Clear(); //flashed black 2 times. long, short



    //Create a new image cache
    UBYTE *BWImage;
    /* you have to edit the startup_stm32fxxx.s file and set a big enough heap size */
    UWORD BWImagesize = ((EPD_4IN2_WIDTH % 8 == 0) ? (EPD_4IN2_WIDTH / 8 ) : (EPD_4IN2_WIDTH / 8 + 1)) * EPD_4IN2_HEIGHT;
    if ((BWImage = (UBYTE *)malloc(BWImagesize)) == NULL) {
    printf("Failed to apply for black memory...\r\n");
    while (1);
    }
    printf("Paint_NewImage\r\n");
    Paint_NewImage(BWImage, EPD_4IN2_WIDTH, EPD_4IN2_HEIGHT, 0, WHITE);

      
    printf("show image for array\r\n");
    Paint_SelectImage(BWImage);
    Paint_Clear(WHITE);
    Paint_DrawBitMap(gImage_4in2);  //to convert image use: python3 img2array.py -i image.png
    EPD_4IN2_Display(BWImage);
    free(BWImage);
    BWImage=NULL;

    DEV_Delay_ms(10000);



    
    // ########## Grayscale
    Serial.println("e-Paper init 4gray");
    DEV_Delay_ms(1000);
    EPD_4IN2_Init_4Gray();
    UBYTE *GSImage;
    UWORD GSImagesize = ((EPD_4IN2_WIDTH % 8 == 0) ? (EPD_4IN2_WIDTH / 4 ) : (EPD_4IN2_WIDTH / 4 + 1)) * EPD_4IN2_HEIGHT;
    if ((GSImage = (UBYTE *)malloc(GSImagesize)) == NULL) {
        printf("Failed to apply for black memory...\r\n");
        while (1);
    }
    Paint_NewImage(GSImage, EPD_4IN2_WIDTH, EPD_4IN2_HEIGHT, 0, WHITE);
    Paint_SelectImage(GSImage);
    Paint_SetScale(4);
    
    
    /*
    Paint_Clear(WHITE);
    Paint_DrawPoint(10, 80, BLACK, DOT_PIXEL_1X1, DOT_STYLE_DFT);
    Paint_DrawPoint(10, 90, BLACK, DOT_PIXEL_2X2, DOT_STYLE_DFT);
    Paint_DrawPoint(10, 100, BLACK, DOT_PIXEL_3X3, DOT_STYLE_DFT);
    Paint_DrawLine(20, 70, 70, 120, BLACK, DOT_PIXEL_1X1, LINE_STYLE_SOLID);
    Paint_DrawLine(70, 70, 20, 120, BLACK, DOT_PIXEL_1X1, LINE_STYLE_SOLID);
    Paint_DrawRectangle(20, 70, 70, 120, BLACK, DOT_PIXEL_1X1, DRAW_FILL_EMPTY);
    Paint_DrawRectangle(80, 70, 130, 120, BLACK, DOT_PIXEL_1X1, DRAW_FILL_FULL);
    Paint_DrawCircle(45, 95, 20, BLACK, DOT_PIXEL_1X1, DRAW_FILL_EMPTY);
    Paint_DrawCircle(105, 95, 20, WHITE, DOT_PIXEL_1X1, DRAW_FILL_FULL);
    Paint_DrawLine(85, 95, 125, 95, BLACK, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);
    Paint_DrawLine(105, 75, 105, 115, BLACK, DOT_PIXEL_1X1, LINE_STYLE_DOTTED);
    Paint_DrawString_EN(10, 0, "waveshare", &Font16, BLACK, WHITE);
    Paint_DrawString_EN(10, 20, "hello world", &Font12, WHITE, BLACK);
    Paint_DrawNum(10, 33, 123456789, &Font12, BLACK, WHITE);
    Paint_DrawNum(10, 50, 987654321, &Font16, WHITE, BLACK);
    Paint_DrawString_CN(140, 0, "你好abc", &Font12CN, GRAY1, GRAY4);
    Paint_DrawString_CN(140, 40, "你好abc", &Font12CN, GRAY2, GRAY3);
    Paint_DrawString_CN(140, 80, "你好abc", &Font12CN, GRAY3, GRAY2);
    Paint_DrawString_CN(140, 120, "你好abc", &Font12CN, GRAY4, GRAY1);

    Paint_DrawString_CN(220, 0, "微雪电子", &Font24CN, GRAY1, GRAY4);
    Paint_DrawString_CN(220, 40, "微雪电子", &Font24CN, GRAY2, GRAY3);
    Paint_DrawString_CN(220, 80, "微雪电子", &Font24CN, GRAY3, GRAY2);
    Paint_DrawString_CN(220, 120, "微雪电子", &Font24CN, GRAY4, GRAY1);
    */
    
    Serial.println("e-Paper Start Lines Test");
    DEV_Delay_ms(1000);
    for (uint16_t i=0;i<100;i++) {
        Serial.print("Lines ystart="); 
        Serial.print(i%2);
        Serial.print(" i="); 
        Serial.println(i);
        Paint_Clear(WHITE);
        for (uint16_t y=i%2;y<EPD_4IN2_HEIGHT;y=y+2) {
            Paint_DrawLine(0, y, EPD_4IN2_WIDTH, y, BLACK, DOT_PIXEL_1X1, LINE_STYLE_SOLID);
        }
        EPD_4IN2_4GrayDisplay(GSImage);
        DEV_Delay_ms(5000);
    }

    EPD_4IN2_Init_Fast();
    EPD_4IN2_Clear();

    printf("Goto Sleep...\r\n");
    EPD_4IN2_Sleep();
    free(GSImage);
    GSImage = NULL;
}

/* The main loop -------------------------------------------------------------*/
void loop()
{
  //
}
